#include <SoftwareSerial.h> 
#include <SD.h>
#define CS 4  
#define FILENAME "saida.txt"
#define FILENAME2 "dados.txt"  
SoftwareSerial mySerial(2, 3);//define os pinos 2 e 3 para RX e TX
File myFile;
char lerID[] = {0xAA , 0xBB, 0x02, 0x20, 0x22};//0x eh usado para definir como hexadecimal
char tmp;  //usado para receber o caracter lido do arquivo
int leitura[12], tag_lidadoarquivo[4];

void setup()
{
	pinMode(10, OUTPUT);// Inicia o pino 10 como output: Obrigatrio pela biblioteca do SD 
	Serial.begin(9600); // Inicia a porta serial
	Serial.println("Inicializando SD...");  
	pinMode(CS, OUTPUT);//Inicializando pino CS como output  
	if (!SD.begin(CS))//Inicializando SD card
	{  
		Serial.println("Falha!");  
		return;  
	}  
	Serial.println("SD iniciado com sucesso!"); 
	mySerial.begin(19200);//Inicializando mySrial: comunicacao com o modulo RFID
}

void loop()
{
	delay (2000);//uma pequena pausa entre as passagens do loop
	int IDbyte,j,i,checksumTAG,checksumARQ,primeiro_PontoVirgula,primeiro_byte;
	int cod_validade=2;
	char temp;
	IDbyte=j=i=checksumTAG=checksumARQ=primeiro_PontoVirgula=primeiro_byte=0;

	for (j =0 ; j < 5 ; j++)//Envia comando para leitura do tag
		mySerial.write(lerID[j]); //Serial.println(lerID[j],HEX);
	for (j =0 ; j < 12 ; j++) //Limpa o Buffer de leitura dos tags
		leitura[j] = 0;
	j=0;//inicializa a variavel j para o while

    if(mySerial.available())//Se houver bytes a serem lidos
	{
		while (mySerial.available())//Enquanto houver bytes a serem lidos
	    {
			leitura[j]= mySerial.read(); //buffer para armazenar o
			j++;
	    }
	       //-------------- leitura do arquivo dados no carto SD
		   
        if(j==9) //so entra se for lida resposta com sucesso da leitura das TAG
        { // a resposta de falha eh AABB02DFDD que d um j=5, logo nao entra no if
			Serial.println();//Imprime na serial monitor do Arduino
			Serial.println("Leitura do ID ");
			myFile = SD.open(FILENAME2, FILE_READ);//Abrindo o arquivo para leitura  
			if(!myFile)
               Serial.println("Falha ao abrir o arquivo dados!");
               delay (100);
			while(myFile.available()>0)//Enquanto nao chega no fim do arquivo  
			{  
				i=0; //variavel usada para verificacao se o indice do vetor e par ou impar
				while ((temp = myFile.read()) != '\n') //a ideia e a informacao no arquivo txt ser : JJHHIIUU;1;       1 para valido e 0 para invalido
				{//  Serial.print(temp);
					if((temp>='0')&&(temp<='9'))  
					{
						temp-='0'; // converte o caracter ASCII para um valor inteiro
					}else if((temp>='A')&&(temp<='F'))
					{
						temp=(temp+10)-'A';	// converte o caracter ASCII para um valor inteiro
					}
					if((i&1)==1 && i<8)//se o numero for impar, junte dois dgitos de 4 bits em um byte de 8 bits
					{
						tag_lidadoarquivo[i/2]=(temp | (primeiro_byte<<4));//movimenta o primeiro digito de 4 bits para a esquerda e adiciona um novo digito
					}
					primeiro_byte=temp;//armazena o primeiro byte lido
					if(i==9)//s le a validade no primeiro ponto e virgula
					{
						cod_validade=temp;      
                    }
                    i++; 
				}//fim da leitura do cod TAG e validade       
                IDbyte=0; checksumARQ=0; checksumTAG=0;
				for (j=4 ; j<8 ; j++)// Retira apenas os Bytes com o ID dos tag
				{
                    checksumTAG^=leitura[j];//Calculo do checksum da TAG
                    checksumARQ^=tag_lidadoarquivo[j-4];//Calculo do checksum da leitura do arquivo dados.txt
					Serial.print("leitura TAG: "); Serial.print(leitura[j],HEX); Serial.print("    leitura arquivo: ");Serial.println(tag_lidadoarquivo[j-4],HEX);
					if (leitura[j]==tag_lidadoarquivo[j-4])
						IDbyte++;			
				}
				Serial.print("leitura IDbyte: "); Serial.println(IDbyte);
                Serial.print("ChecksumARQ: ");Serial.print(checksumARQ);
                Serial.print(" ChecksumTAG: ");Serial.println(checksumTAG);
				//_________________________________________________________________________
			
				if(IDbyte==4 && checksumTAG==checksumARQ)//dupla confirmacao: numero de coincidencias e checksum 
				{
                    myFile.close();//Fechando arquivo dados.txt  
					myFile = SD.open(FILENAME, FILE_WRITE);//Abrindo o arquivo para escrita  
					if (myFile)
					{
						if(cod_validade==1)//gravara os dados no cartao SD
						{
                            for (j=4 ; j<8 ; j++)// Retira apenas os Bytes com o ID dos tag
							{
								myFile.print(leitura[j],HEX);//imprime no arquivo saida.txt
							}
							myFile.print(";");
							myFile.print(cod_validade);
							myFile.print(";");
							myFile.println("Cartao dentro da validade;");
							Serial.println("Habita a entrada automatica");
						}else// gravar os dados no cartao SD com a informacao da validade vencida
						{
                            for (j=4 ; j<8 ; j++)//Retira apenas os Bytes com o ID dos tag
							{
								myFile.print(leitura[j],HEX);
							}
							myFile.print(";");
							myFile.print(cod_validade);
							myFile.print(";");
							myFile.println("Cartao vencido! Acionar o usuario;");
							Serial.println("Habita a entrada para atendimento manual.csv");
                        }
					} else // se o arquivo nao abrir, imprime erro
					{
						Serial.println("erro na abertura do arquivo saida.csv");
					}
					myFile.close(); // Fechando arquivo saida.csv
					continue;//sai do while pois ja encontrou o TAG
                }// Fim do if(IDbyte==4 && checksumTAG==checksumARQ)
				else{
						Serial.println("Habita a entrada para atendimento manual.csv");				
					}
			}//fim do while de leitura do arquivo
        }//if da TAG de insucesso
	}// Fim do if(mySerial.available())
}//fim do Void loop	